/**
 * Application
 */
import React, { Fragment, FunctionComponent, useRef, useState, useCallback } from 'react';

import { BryntumTaskBoard } from '@bryntum/taskboard-react';
// import { TaskBoard, ProjectModel } from '@bryntum/taskboard';
import { useTaskBoardConfig } from './AppConfig';
import './App.scss';
import { TaskBoard } from '@bryntum/taskboard';

const App: FunctionComponent = () => {
    const taskBoardRef = useRef<BryntumTaskBoard>(null);
    const taskBoardInstance = () => taskBoardRef.current?.instance as TaskBoard;

    const handleAddButtonClick = useCallback(() => {
        const taskBoard = taskBoardInstance();

        const id = taskBoard.swimlanes.count;
        taskBoard.swimlanes.add({ id, text : `Swimlane #${id}` });
        taskBoard.scrollToSwimlane(id);


        // taskBoard.widgetMap.removeButton.disabled = false;
    }, []);

    const [taskBoardConfig] = useState(useTaskBoardConfig(handleAddButtonClick));

    return (
        <>
            <BryntumTaskBoard
                ref={taskBoardRef}
                {...taskBoardConfig}
            />
        </>
    );
};

export default App;
